【POJ】Buy Tickets(思路 + 线段树)

一开始没有思路,之后问了一下学长,需要逆向处理输入。

最后一个加入队列的肯定是没有冲突的,所以我们可以从最后一个开始处理,从后往前,找第 i + 1个空着的地方。

线段树的话记录 区间中 空白位置的个数。

13441833 201301052100 2828 Accepted 5368K 1704MS C++ 1690B 2014-09-14 21:19:45

#include<iostream>
#include<cstdlib>
#include<cstdio>
#include<string>
#include<cstring>
#include<cmath>
#include<vector>
#include<queue>
#include<set>
#include<map>
#include<stack>
#include<algorithm>
using namespace std;
typedef long long LL;
/*=====================================*/
const int maxn = 200000 + 10;
int tree[maxn << 2];
int  ans[maxn << 2];
int array[maxn],value[maxn];
int n;
void BuildTree(int L,int R,int pos){
    if(L == R){
        tree[pos] = 1; //在区间L,R之间有几个空位
        return ;
    }
    int m = (L + R) >> 1;
    BuildTree(L,m,pos << 1);
    BuildTree(m + 1, R ,(pos << 1)|1);
    tree[pos] = tree[pos << 1] + tree[(pos << 1)|1];
    return ;
}
void UpDate(int k,int L,int R,int pos,int value){
    if(L == R){
        ans[pos] = value;
        tree[pos] --;
        return ;
    }
    int m = (L + R) >> 1;
    int e1 = tree[pos << 1];
    int e2 = tree[(pos << 1)|1];
    if(e1 >= k)
        UpDate(k,L,m,pos << 1,value);
    else
        UpDate(k - e1,m + 1,R, (pos << 1)|1,value);
    tree[pos] = tree[pos << 1] + tree[(pos << 1)|1];
}
void ShowTree(int L,int R,int pos){
    if(L == R){
        printf("%d",ans[pos]);
        return ;
    }
    int m = (L + R)  >> 1;
    ShowTree(L, m, pos << 1);printf(" ");ShowTree(m + 1, R ,(pos << 1)|1);
}
int main(){
    while(scanf("%d",&n) != EOF){
        BuildTree(1,n,1); //log(n)的时间复杂度建树
        for(int i = 0 ; i < n ; i++)
            scanf("%d%d",&array[i],&value[i]);
        for(int i = n - 1 ; i >= 0 ; i --){ //找到第 i + 1个为空的位置
            UpDate(array[i] + 1,1,n,1,value[i]);  //nlog(n)的时间复杂度进行更新
        }
        ShowTree(1,n,1);  //log(n)的时间复杂度打印路径
        printf("\n");
    }
    return 0;
}
时间: 2024-10-03 14:26:47

【POJ】Buy Tickets(思路 + 线段树)的相关文章

【POJ】Buy Tickets(线段树)

点更新用法很巧妙的一道题.倒序很容易的找到该人的位置,而update操作中需要不断的变化下标才能合理的插入.看了别人写的代码,学习了. 1 #include <iostream> 2 #include <cstring> 3 #include <cstdio> 4 #include <map> 5 using namespace std; 6 7 const int maxn = 2e5 + 10; 8 int sumv[maxn << 2],

POJ 2828 Buy Tickets (线段树,区间修改)

逆向思维.从最后一位开始考虑,用线段树查询空位置. #include <iostream> #include <cstring> #include <cstdlib> #include <cstdio> #include <algorithm> #include <vector> #include <queue> #include <stack> #include <set> #include &l

POJ 2828 Buy Tickets (线段树 单点更新 变形)

题目链接 题意:有N个人排队,给出各个人想插队的位置和标识,要求输出最后的序列. 分析:因为之前的序列会因为插队而变化,如果直接算时间复杂度很高,所以可以用 线段树逆序插入,把序列都插到最后一层,len记录该区间里还剩余多少位置,插入的时候就插到剩余的第几个位置, 比如1,2已经插入了,如果再想插入第3个位置,则实际上插入的是5. 因为是逆序的,所以在3之前除了现在的1,2 还有之前的1,2. 1 #include <iostream> 2 #include <cstdio> 3

POJ2828 Buy Tickets 【线段树】+【单点更新】+【逆序】

Buy Tickets Time Limit: 4000MS   Memory Limit: 65536K Total Submissions: 12296   Accepted: 6071 Description Railway tickets were difficult to buy around the Lunar New Year in China, so we must get up early and join a long queue- The Lunar New Year wa

POJ - 2828 - Buy Tickets (线段树)

题目传送:Buy Tickets 思路:线段树,从后往前依次插入,插入一个更新一次 AC代码: #include <cstdio> #include <cstring> #include <iostream> #include <algorithm> #include <cmath> #include <queue> #include <stack> #include <vector> #include <

poj 2828 Buy Tickets 【线段树点更新】

题目:poj 2828 Buy Tickets 题意:有n个人排队,每个人有一个价值和要插的位置,然后当要插的位置上有人时所有的人向后移动一位当这个插入到这儿,如果没有直接插进去. 分析:分析发现直接插入移动的话花时间太多,我们可不可以用逆向思维.从后往前来,因为最后一个位置是肯定能确定的,而其他的则插入空的第某个位置. 比如第一组样例: 4 0 77 1 51 1 33 2 69 开始时候位置都为空 编号0 1 2 3 首先从最后一个来2 69 第二个位置空,则可以直接放 然后编号变为0 1

【POJ】2828 Buy Tickets(线段树+特殊的技巧/splay)

http://poj.org/problem?id=2828 一开始敲了个splay,直接模拟. tle了.. 常数太大.. 好吧,说是用线段树.. 而且思想很拽.. (貌似很久以前写过貌似的,,) 我们线段树维护的区间不再是人了.. 而是这个区间剩余的的座位.. 比如我现在要坐第一张,但是人已经坐了,即这个区间已经没有位置了..那就要往后坐. 所以我们逆序添加,,因为后来人插队前边人管不着... 所以后来人一定是先定座位的.. 每一次维护这个座位区间.. 如果左边这个区间座位比我要坐的座位号要

poj 2828 Buy Tickets (线段树 单节点 查询位置更新)

Buy Tickets Time Limit: 4000MS   Memory Limit: 65536K Total Submissions: 15533   Accepted: 7759 Description Railway tickets were difficult to buy around the Lunar New Year in China, so we must get up early and join a long queue- The Lunar New Year wa

poj 2828 buy Tickets 用线段树模拟带插入的队列

Buy Tickets Time Limit: 1 Sec  Memory Limit: 256 MB 题目连接 http://acm.hdu.edu.cn/showproblem.php?pid=2795 Description Railway tickets were difficult to buy around the Lunar New Year in China, so we must get up early and join a long queue… The Lunar New

POJ 2828 Buy Tickets(线段树)

Language: Default Buy Tickets Time Limit: 4000MS   Memory Limit: 65536K Total Submissions: 13847   Accepted: 6926 Description Railway tickets were difficult to buy around the Lunar New Year in China, so we must get up early and join a long queue- The